; -------------------------------------------------------------------------------------------------------------- ;
; Snokie - Protected - snokie.prg
; -------------------------------------------------------------------------------------------------------------- ;
                          * equ $0326
; -------------------------------------------------------------------------------------------------------------- ;
; compiler settings
; -------------------------------------------------------------------------------------------------------------- ;
                          incdir  ..\inc                  ; C64 System Includes

C64VicII                  include c64_vic.asm             ; Video Interface Chip (VIC-II) Registers       $d000-$d02e
C64Colors                 include c64_color.asm           ; Colour RAM Address / Colours
C64Memory                 include c64_mem.asm             ; Standard Zeropage / Stack / Vector constants
C64Kernal                 include c64_kernal.asm          ; Kernal Routines entry points $e000-$ffff
; -------------------------------------------------------------------------------------------------------------- ;
; variable definitions
; -------------------------------------------------------------------------------------------------------------- ;
Snokie1_Start             equ  $1000      ; main program start address
Snokie1_End               equ  $9fff      ; main program end   address
Snokie1_EntryPoint        equ  $713e      ; main program start code
; -------------------------------------------------------------------------------------------------------------- ;
AutoStart                 subroutine      ; 
                          dc.w Main       ; Vector: Indirect entry to Kernal CHROUT Routine
                          dc.w ISTOP_Ini  ; Vector: Indirect entry to Kernal STOP   Routine
                          dc.w IGETIN_Ini ; Vector: Indirect entry to Kernal GETIN  Routine
                          dc.w ICLALL_Ini ; Vector: Indirect entry to Kernal CLALL  Routine
                          dc.w CNBINV_Ini ; Vector: BRK Instruction Interrupt Address
                          dc.w ILOAD_Ini  ; Vector: Indirect entry to Kernal LOAD   Routine
                          dc.w ISAVE_Ini  ; Vector: Indirect entry to Kernal SAVE   Routine
                          dc.b $00        ; 
                          dc.b $00        ; 
                          dc.b $00        ; 
                          dc.b $00        ; 
                          dc.b $00        ; 
                          dc.b $00        ; 
                          dc.b $00        ; 
; -------------------------------------------------------------------------------------------------------------- ;
TabNewPgmLink             equ  *          ; new program link data for block 17_0
TabNewPgmLink_Track       dc.b $11        ; 
TabNewPgmLink_Sector      dc.b $0a        ; 
; -------------------------------------------------------------------------------------------------------------- ;
Main                      subroutine                      ; 
                          sei                             ; 
                          jsr RESTOR                      ; Kernal($FF8A) Restore default I/O vectors ($FD15)
                          
                          lda #<NMI                       ; 
                          sta NMINV_LO                    ; Vector($0318/$0319): Hardware NMI interrupt address at ($FE47)
                          lda #>NMI                       ; 
                          sta NMINV_HI                    ; Vector($0318/$0319): Hardware NMI interrupt address at ($FE47)
                          jsr ReadCheckBlock_35_0         ; 
                          
                          lda TabDiskCheckID              ; 
.ChkProtected             cmp #$02                        ; 
.DoForEverAndEverAgain    bne .DoForEverAndEverAgain      ; disk was bad
                          
.SetNewPgmLink            lda TabNewPgmLink_Track         ; disk check was good so correct pgm link
                          sta TabPgmLink_Track            ; 
                          lda TabNewPgmLink_Sector        ; 
                          sta TabPgmLink_Sector           ; 
                          jsr ReadWriteBlock_17_0         ; 
                          
                          ldy #LT_BLUE                    ; 
                          sty EXTCOL                      ; VIC($D020) Border Color
                          sty BGCOL0                      ; VIC($D021) Background Color 0
                          
.ScreenMsgOut             lda TabScreenMsg,y              ; 
                          sec                             ; 
                          sbc #$40                        ; 
                          sta ScreenMsgOut,y              ; 
                          
                          lda #BLUE                       ; 
                          sta [COLORAM + $01c4],y         ; 
                          
                          dey                             ; 
                          bne .ScreenMsgOut               ; 
                          
                          lda #$01                        ; set logical file number
                          ldx #$08                        ; set device number
                          ldy #$01                        ; set secondary command number ($00 = new load address)
                          jsr SETLFS                      ; Kernal($FFBA) Set logical file parameters ($FE00)
                          
                          lda #Snokie_FileName_Len        ; 
                          ldx #<Snokie_FileName           ; 
                          ldy #>Snokie_FileName           ; 
                          jsr SETNAM                      ; Kernal($FFBD) Set filename parameters ($FDF9)
                          
                          lda #$00                        ; flag: load
                          ldx #<Snokie1_Start             ; alternate start address
                          ldy #>Snokie1_Start             ; 
                          jsr LOAD                        ; Kernal($FFD5) Load from device (via $330 to $F49E)
                          
.RestoreOldPgmLink        lda #$00                        ; 
                          sta TabPgmLink_Track            ; 
                          lda #$15                        ; 
                          sta TabPgmLink_Sector           ; 
                          jsr ReadWriteBlock_17_0         ; 
                          
                          jmp DecompressData              ; 
; -------------------------------------------------------------------------------------------------------------- ;
NMI                       rti                             ; 
; -------------------------------------------------------------------------------------------------------------- ;
; DecompressData          Does    : 
;                         Expects : 
;                         Returns : 
; -------------------------------------------------------------------------------------------------------------- ;
DecompressData            subroutine                      ; 
                          lda #$10                        ; 
                          sta .__CopyFrom_Hi              ; 
                          sta .__CopyTo_Hi                ; 

.__CopyFrom_Lo            equ [* + $01]                   ; 
.__CopyFrom_Hi            equ [* + $02]                   ; 
.GetNextByte              lda $ff00                       ; from $1000
.Decompress               eor #$4c                        ; .#..##..
.__CopyTo_Lo              equ [* + $01]                   ; 
.__CopyTo_Hi              equ [* + $02]                   ; 
.SetNextByte              sta $ff00                       ; to   $1000
                          
.IncPtr_Lo                inc .__CopyFrom_Lo              ; 
                          inc .__CopyTo_Lo                ; 
                          
.GetPtr_Lo                lda .__CopyTo_Lo                ; 
.ChkPtr_Lo_Page           bne .ChkPtr_Lo_Max              ; page still not copied
                          
.IncPtr_Hi                inc .__CopyFrom_Hi              ; 
                          inc .__CopyTo_Hi                ; 
                          
.ChkPtr_Lo_Max            cmp #<Snokie1_End               ; 
                          bne .GetNextByte                ; 
                          
.GetPtr_Hi_Max            lda .__CopyFrom_Hi              ; 
.ChkPtr_Hi_Max            cmp #>Snokie1_End               ; 
                          bne .GetNextByte                ; 
                          
DecompressDataX           jmp Snokie1_EntryPoint          ; start
; -------------------------------------------------------------------------------------------------------------- ;
Snokie_FileName           equ  *   ; 
                          dc.b $53 ; s
                          dc.b $4e ; n
                          dc.b $4f ; o
                          dc.b $4b ; k
                          dc.b $49 ; i
                          dc.b $45 ; e
                          dc.b $31 ; 1
Snokie_FileName_Len       equ  [* - Snokie_FileName] ; 
; -------------------------------------------------------------------------------------------------------------- ;
TabScreenMsg              equ  [* - $01] ; 
                          dc.b $4c ; l
                          dc.b $4f ; o
                          dc.b $41 ; a
                          dc.b $44 ; d
                          dc.b $49 ; i
                          dc.b $4e ; n
                          dc.b $47 ; g
                          dc.b $60 ; <space> + $40
                          dc.b $53 ; s
                          dc.b $4e ; n
                          dc.b $4f ; o
                          dc.b $4b ; k
                          dc.b $49 ; i
                          dc.b $45 ; e
TabScreenMsg_Len          equ  [* - TabScreenMsg - $01] ; 
; -------------------------------------------------------------------------------------------------------------- ;
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
                          dc.b $00 ; ........
; -------------------------------------------------------------------------------------------------------------- ;
Screen_Start              equ  *   ; 
Screen_Row_01             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_02             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_03             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_04             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_05             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_06             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_07             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_08             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_09             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_10             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_11             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_12             dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
ScreenMsgOut              dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
Screen_Row_13             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_14             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_15             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_16             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_17             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_18             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_19             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_20             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_21             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_22             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_23             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_24             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Row_25             dc.b $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
Screen_Unused             dc.b $00, $c0, $00, $40, $e4, $d6, $08, $8f, $00, $10, $00, $00, $44, $48, $cc, $54
                          
Screen_SpritePtrs         dc.b $04 ; 
                          dc.b $18 ; 
                          dc.b $cc ; 
                          dc.b $98 ; 
                          dc.b $1c ; 
                          dc.b $44 ; 
                          dc.b $78 ; 
                          dc.b $e0 ; 
                          
BasicStart                dc.b $00 ; 
; -------------------------------------------------------------------------------------------------------------- ;
TabDiskCheckID            dc.b $0d ; <enter>
; -------------------------------------------------------------------------------------------------------------- ;
; ReadCheckBlock_35_0     Does    : 
;                         Expects : 
;                         Returns : 
; -------------------------------------------------------------------------------------------------------------- ;
ReadCheckBlock_35_0       subroutine                      ; 
                          lda #$02                        ; set logical file number
                          tay                             ; set secondary command number ($00 = new load address)
                          ldx #$08                        ; set device number
                          jsr _SETLFS                     ; Real address($FE00) Set logical file parameters
                          
                          lda #U1_FileName_Len            ; 
                          ldx U1_FileName_Lo              ; direct access channel name
                          ldy U1_FileName_Hi              ; 
                          jsr _SETNAM                     ; Real address($FDF9) Set filename parameters
                          jsr _OPEN                       ; Real address($F34A) Open a logical file (via $31A)
                          
.CommandChannel           lda #$0f                        ; set logical file number
                          tay                             ; set secondary command number ($00 = new load address)
                          ldx #$08                        ; set device number
                          jsr _SETLFS                     ; Real address($FE00) Set logical file parameters
                          
                          lda #$00                        ; 
                          jsr _SETNAM                     ; Real address($FDF9) Set filename parameters
                          jsr _OPEN                       ; Real address($F34A) Open a logical file (via $31A)
                          
.CommandChannelOut        ldx #$0f                        ; 
                          jsr _CHKOUT                     ; Real address($F250) Define an output channel (via $320)
                          
                          ldy #$00                        ; 
.CommandChannelOut_U1     lda BlockRead_U1,y              ; 
                          jsr _CHROUT                     ; Real address($F1CA) Output a character (via $326)
                          
                          iny                             ; 
                          cpy #BlockRead_U1_Len           ; 
                          bne .CommandChannelOut_U1       ; 
                          
.GetEnter                 lda #$0d                        ; 
.OutEnter                 jsr _CHROUT                     ; Real address($F1CA) Output a character (via $326)
                          jsr _CLRCHN                     ; Real address($F333) Restore default devices (via $322)
                          
.DataInFirstFour          ldx #$02                        ; 
                          jsr _CHKIN                      ; Real address($F20E) Define an input channel (via $31E)
                          jsr _CHRIN                      ; Real address($F157) Input a character (via $324)
                          jsr _CHRIN                      ; Real address($F157) Input a character (via $324)
                          jsr _CHRIN                      ; Real address($F157) Input a character (via $324)
                          
                          ldy #$00                        ; 
.DataInNextFour           jsr _CHRIN                      ; Real address($F157) Input a character (via $324)
                          
.ChkProtection            cmp TabDiskProtection,y         ; 
.DiskWasBad               bne .ForEverAndEver             ; 
                          
                          iny                             ; 
                          cpy #TabDiskProtection_Len      ; 
                          beq .DiskWasGood                ; 
                          
                          jmp .DataInNextFour             ; 
; -------------------------------------------------------------------------------------------------------------- ;
.ForEverAndEver           jmp .ForEverAndEver             ; 
; -------------------------------------------------------------------------------------------------------------- ;
.DiskWasGood              jsr _CLRCHN                     ; Real address($F333) Restore default devices (via $322)
                          
.GetGoodDiskID            lda #$02                        ; 
.SetGoodDiskID            sta TabDiskCheckID              ; 
                          
.CloseData                jsr _CLOSE                      ; Real address($F291) Close a logical file (via $31C)
                          
                          lda #$0f                        ; 
.CloseCommand             jsr _CLOSE                      ; Real address($F291) Close a logical file (via $31C)
                          
ReadCheckBlock_35_0X      rts                             ; 
; -------------------------------------------------------------------------------------------------------------- ;
U1_FileName_Lo            dc.b <U1_FileName ; 
U1_FileName_Hi            dc.b >U1_FileName ; 
; -------------------------------------------------------------------------------------------------------------- ;
U1_FileName               dc.b "#" ; direct access channel name 
U1_FileName_Len           equ  [* - U1_FileName] ; 
; -------------------------------------------------------------------------------------------------------------- ;
BlockRead_U1              equ  *   ; 
                          dc.b $55 ; u - block read
                          dc.b $31 ; 1
                          dc.b $20 ; <space>
                          dc.b $32 ; 2 - channel num
                          dc.b $20 ; <space>
                          dc.b $30 ; 0 - disk num (1541 always 0)
                          dc.b $20 ; <space>
                          dc.b $33 ; 3 - track num
                          dc.b $35 ; 5
                          dc.b $20 ; <space>
                          dc.b $30 ; 0 - sector num
BlockRead_U1_Len          equ  [* - BlockRead_U1] ; 
; -------------------------------------------------------------------------------------------------------------- ;
TabDiskProtection         dc.b $05 ; <WHITE>
                          dc.b $4b ; k
                          dc.b $23 ; #
                          dc.b $6e ; N
TabDiskProtection_Len     equ  [* - TabDiskProtection] ; 
; -------------------------------------------------------------------------------------------------------------- ;
                          dc.b $42 ; b
                          dc.b $4c ; l
                          dc.b $49 ; i
                          dc.b $43 ; c
                          dc.b $20 ; <space>
                          dc.b $44 ; d
                          dc.b $4f ; o
                          dc.b $4d ; m
                          dc.b $41 ; a
                          dc.b $49 ; i
                          dc.b $4e ; n
                          dc.b $20 ; <space>
                          dc.b $50 ; p
                          dc.b $52 ; r
                          dc.b $4f ; o
                          dc.b $47 ; g
; -------------------------------------------------------------------------------------------------------------- ;
TabPgmLink_Track          dc.b $00 ; 
TabPgmLink_Sector         dc.b $15 ; 
; -------------------------------------------------------------------------------------------------------------- ;
; ReadWriteBlock_17_0     Does    : corrects/destroys the SNOKIE1 file link chain
;                         Expects : 
;                         Returns : 
; -------------------------------------------------------------------------------------------------------------- ;
ReadWriteBlock_17_0       subroutine                      ; 
                          lda #$02                        ; set logical file number
                          tay                             ; set secondary command number ($00 = new load address)
                          ldx #$08                        ; set device number
                          jsr SETLFS                      ; Kernal($FFBA) Set logical file parameters ($FE00)
                          
                          lda #$01                        ; 
                          ldx U2_FileName_Lo              ; direct access channel name
                          ldy U2_FileName_Hi              ; 
                          jsr SETNAM                      ; Kernal($FFBD) Set filename parameters ($FDF9)
                          jsr OPEN                        ; Kernal($FFC0) Open a logical file (via $31A to $F34A)
                          
                          lda #$0f                        ; set logical file number
                          tay                             ; set secondary command number ($00 = new load address)
                          ldx #$08                        ; set device number
                          jsr SETLFS                      ; Kernal($FFBA) Set logical file parameters ($FE00)
                          
                          lda #$00                        ; 
                          jsr SETNAM                      ; Kernal($FFBD) Set filename parameters ($FDF9)
                          jsr OPEN                        ; Kernal($FFC0) Open a logical file (via $31A to $F34A)
                          
                          ldx #$0f                        ; 
                          jsr CHKOUT                      ; Kernal($FFC9) Define an output channel (via $320 to $F250)
                          
                          ldy #$00                        ; 
.CommandChannelOut_U1     lda BlockRead_U1_Check,y        ; 
                          jsr CHROUT                      ; Kernal($FFD2) Output a character (via $326 to $F1CA)
                          
                          iny                             ; 
                          cpy #BlockRead_U1_Check_Len     ; 
                          bne .CommandChannelOut_U1       ; 
                          
.GetEnter                 lda #$0d                        ; 
.OutEnter                 jsr CHROUT                      ; Kernal($FFD2) Output a character (via $326 to $F1CA)
                          jsr CLRCHN                      ; Kernal($FFCC) Restore default devices (via $322 to $F333)
                          
.SetDataOut               ldx #$02                        ; 
                          jsr CHKOUT                      ; Kernal($FFC9) Define an output channel (via $320 to $F250)
                          
                          lda TabPgmLink_Track            ; 
                          jsr CHROUT                      ; Kernal($FFD2) Output a character (via $326 to $F1CA)
                          
                          lda TabPgmLink_Sector           ; 
                          jsr CHROUT                      ; Kernal($FFD2) Output a character (via $326 to $F1CA)
                          jsr CLRCHN                      ; Kernal($FFCC) Restore default devices (via $322 to $F333)
                          
                          ldx #$0f                        ; 
                          jsr CHKOUT                      ; Kernal($FFC9) Define an output channel (via $320 to $F250)
                          
                          ldy #$00                        ; 
.CommandChannelOut_U2     lda BlockWrite_U2_Check,y       ; 
                          jsr CHROUT                      ; Kernal($FFD2) Output a character (via $326 to $F1CA)
                          
                          iny                             ; 
                          cpy #BlockWrite_U2_Check_Len    ; 
                          bne .CommandChannelOut_U2       ; 
                          
                          jsr CLRCHN                      ; Kernal($FFCC) Restore default devices (via $322 to $F333)
                          
                          ldx #$0f                        ; 
                          jsr CLRCHN                      ; Kernal($FFCC) Restore default devices (via $322 to $F333)
                          
                          lda #$02                        ; 
                          jsr CLOSE                       ; Kernal($FFC3) Close a logical file (via $31C to $F291)
                          
                          lda #$0f                        ; 
                          jsr CLOSE                       ; Kernal($FFC3) Close a logical file (via $31C to $F291)
                          
ReadWriteBlock_17_0X      rts                             ; 
; -------------------------------------------------------------------------------------------------------------- ;
U2_FileName_Lo            dc.b <U2_FileName ; 
U2_FileName_Hi            dc.b >U2_FileName ; 
; -------------------------------------------------------------------------------------------------------------- ;
U2_FileName               dc.b "#" ; direct access channel name 
U2_FileName_Len           equ  [* - U2_FileName] ; 
; -------------------------------------------------------------------------------------------------------------- ;
BlockWrite_U2_Check       equ  *   ; 
                          dc.b $55 ; u
                          dc.b $32 ; 2
                          dc.b $20 ; <space>
                          dc.b $32 ; 2
                          dc.b $20 ; <space>
                          dc.b $30 ; 0
                          dc.b $20 ; <space>
                          dc.b $31 ; 1
                          dc.b $37 ; 7
                          dc.b $20 ; <space>
                          dc.b $30 ; 0
                          dc.b $0d ; <enter>
BlockWrite_U2_Check_Len   equ  [* - BlockWrite_U2_Check] ; 
; -------------------------------------------------------------------------------------------------------------- ;
BlockRead_U1_Check        equ  *   ; 
                          dc.b $55 ; u
                          dc.b $31 ; 1
                          dc.b $20 ; <space>
                          dc.b $32 ; 2
                          dc.b $20 ; <space>
                          dc.b $30 ; 0
                          dc.b $20 ; <space>
                          dc.b $31 ; 1
                          dc.b $37 ; 7
                          dc.b $20 ; <space>
                          dc.b $30 ; 0
BlockRead_U1_Check_Len    equ  [* - BlockRead_U1_Check] ; 
; -------------------------------------------------------------------------------------------------------------- ;
                          dc.b $59 ; y
                          dc.b $09 ; <SHIFT C= on>
                          dc.b $64 ; D
A_0930                    dc.b $00 ; ........
                          dc.b $99 ; <LIGHT GREEN>
                          dc.b $20 ; <space>
                          dc.b $22 ; "
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $24 ; $
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
A_0940                    dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $58 ; x
                          dc.b $59 ; y
                          dc.b $20 ; <space>
                          dc.b $3d ; =
                          dc.b $20 ; <space>
                          dc.b $43 ; c
                          dc.b $4f ; o
                          dc.b $4d ; m
                          dc.b $4d ; m
                          dc.b $41 ; a
                          dc.b $4e ; n
                          dc.b $44 ; d
A_0950                    dc.b $20 ; <space>
                          dc.b $46 ; f
                          dc.b $4f ; o
                          dc.b $52 ; r
                          dc.b $4d ; m
                          dc.b $41 ; a
                          dc.b $54 ; t
                          dc.b $22 ; "
                          dc.b $00 ; ........
                          dc.b $77 ; W
                          dc.b $09 ; <SHIFT C= on>
                          dc.b $6e ; N
                          dc.b $00 ; ........
                          dc.b $99 ; <LIGHT GREEN>
                          dc.b $20 ; <space>
                          dc.b $22 ; "
A_0960                    dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $24 ; $
                          dc.b $30 ; 0
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $57 ; w
A_0970                    dc.b $48 ; h
                          dc.b $45 ; e
                          dc.b $52 ; r
                          dc.b $45 ; e
                          dc.b $3a ; :
                          dc.b $22 ; "
                          dc.b $00 ; ........
                          dc.b $9e ; <YELLOW>
                          dc.b $09 ; <SHIFT C= on>
                          dc.b $78 ; X
                          dc.b $00 ; ........
                          dc.b $99 ; <LIGHT GREEN>
                          dc.b $20 ; <space>
                          dc.b $22 ; "
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
A_0980                    dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $24 ; $
                          dc.b $31 ; 1
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $58 ; x
                          dc.b $20 ; <space>
A_0990                    dc.b $3d ; =
                          dc.b $20 ; <space>
                          dc.b $45 ; e
                          dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $4c ; l
                          dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $43 ; c
                          dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $57 ; w
                          dc.b $22 ; "
                          dc.b $00 ; ........
                          dc.b $ce ; N
                          dc.b $09 ; <SHIFT C= on>
A_09a0                    dc.b $82 ; #.....#.
                          dc.b $00 ; ........
                          dc.b $99 ; <LIGHT GREEN>
                          dc.b $20 ; <space>
                          dc.b $22 ; "
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $2f ; /
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
A_09b0                    dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $59 ; y
                          dc.b $20 ; <space>
                          dc.b $3d ; =
                          dc.b $20 ; <space>
                          dc.b $41 ; a
                          dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $4d ; m
                          dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $4c ; l
A_09c0                    dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $57 ; w
                          dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $53 ; s
                          dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $54 ; t
                          dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $55 ; u
                          dc.b $22 ; "
                          dc.b $00 ; ........
                          dc.b $fc ; ######..
                          dc.b $09 ; <SHIFT C= on>
A_09d0                    dc.b $8c ; <f8>
                          dc.b $00 ; ........
                          dc.b $99 ; <LIGHT GREEN>
                          dc.b $20 ; <space>
                          dc.b $22 ; "
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $5e ; <arrow up>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
A_09e0                    dc.b $45 ; e
                          dc.b $58 ; x
                          dc.b $3a ; :
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $45 ; e
                          dc.b $58 ; x
                          dc.b $45 ; e
                          dc.b $43 ; c
                          dc.b $55 ; u
                          dc.b $54 ; t
                          dc.b $45 ; e
                          dc.b $20 ; <space>
                          dc.b $41 ; a
                          dc.b $53 ; s
                          dc.b $53 ; s
A_09f0                    dc.b $45 ; e
                          dc.b $4d ; m
                          dc.b $42 ; b
                          dc.b $4c ; l
                          dc.b $45 ; e
                          dc.b $52 ; r
                          dc.b $3a ; :
                          dc.b $20 ; <space>
                          dc.b $45 ; e
                          dc.b $41 ; a
                          dc.b $22 ; "
                          dc.b $00 ; ........
                          dc.b $2c ; ,
                          dc.b $0a ; ....#.#.
                          dc.b $96 ; <LIGHT RED>
                          dc.b $00 ; ........
A_0a00                    dc.b $99 ; <LIGHT GREEN>
                          dc.b $20 ; <space>
                          dc.b $22 ; "
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
A_0a10                    dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $4c ; l
                          dc.b $4f ; o
                          dc.b $41 ; a
                          dc.b $44 ; d
                          dc.b $20 ; <space>
                          dc.b $57 ; w
                          dc.b $4f ; o
                          dc.b $52 ; r
                          dc.b $44 ; d
                          dc.b $20 ; <space>
                          dc.b $50 ; p
                          dc.b $52 ; r
                          dc.b $4f ; o
A_0a20                    dc.b $43 ; c
                          dc.b $45 ; e
                          dc.b $53 ; s
                          dc.b $53 ; s
                          dc.b $4f ; o
                          dc.b $52 ; r
                          dc.b $3a ; :
                          dc.b $20 ; <space>
                          dc.b $4c ; l
                          dc.b $57 ; w
                          dc.b $22 ; "
                          dc.b $00 ; ........
                          dc.b $58 ; x
                          dc.b $0a ; ....#.#.
                          dc.b $9b ; <GREY 3>
                          dc.b $00 ; ........
A_0a30                    dc.b $99 ; <LIGHT GREEN>
                          dc.b $20 ; <space>
                          dc.b $22 ; "
                          dc.b $20 ; <space>
                          dc.b $20 ; <space>
                          dc.b $3e ; >
                          dc.b $3e ; >
                          dc.b $39 ; 9
                          dc.b $20 ; <space>
                          dc.b $c3 ; C
                          dc.b $48 ; h
                          dc.b $41 ; a
                          dc.b $4e ; n
                          dc.b $47 ; g
                          dc.b $45 ; e
                          dc.b $53 ; s
A_0a40                    dc.b $20 ; <space>
                          dc.b $c6 ; F
                          dc.b $c1 ; A
                          dc.b $20 ; <space>
                          dc.b $4f ; o
                          dc.b $46 ; f
                          dc.b $20 ; <space>
                          dc.b $44 ; d
                          dc.b $49 ; i
                          dc.b $53 ; s
                          dc.b $4b ; k
                          dc.b $20 ; <space>
                          dc.b $44 ; d
                          dc.b $52 ; r
                          dc.b $49 ; i
                          dc.b $56 ; v
A_0a50                    dc.b $45 ; e
                          dc.b $20 ; <space>
                          dc.b $54 ; t
                          dc.b $4f ; o
                          dc.b $20 ; <space>
                          dc.b $39 ; 9
                          dc.b $22 ; "
                          dc.b $00 ; ........
                          dc.b $5e ; <arrow up>
                          dc.b $0a ; ....#.#.
                          dc.b $a0 ; <shift space>
                          dc.b $00 ; ........
                          dc.b $99 ; <LIGHT GREEN>
                          dc.b $00 ; ........
                          dc.b $8a ; <f4>
                          dc.b $0a ; ....#.#.
A_0a60                    dc.b $aa ; #.#.#.#.
                          dc.b $00 ; ........
                          dc.b $99 ; <LIGHT GREEN>
                          dc.b $20 ; <space>
                          dc.b $22 ; "
                          dc.b $c5 ; E
                          dc.b $58 ; x
                          dc.b $45 ; e
                          dc.b $43 ; c
                          dc.b $55 ; u
                          dc.b $54 ; t
                          dc.b $45 ; e
                          dc.b $20 ; <space>
                          dc.b $43 ; c
                          dc.b $4f ; o
                          dc.b $4d ; m
A_0a70                    dc.b $4d ; m
                          dc.b $41 ; a
                          dc.b $4e ; n
                          dc.b $44 ; d
                          dc.b $53 ; s
                          dc.b $20 ; <space>
                          dc.b $28 ; (
                          dc.b $c5 ; E
                          dc.b $c1 ; A
                          dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $c5 ; E
                          dc.b $cd ; M
                          dc.b $2c ; ,
                          dc.b $20 ; <space>
                          dc.b $c5 ; E
A_0a80                    dc.b $cc ; L
                          dc.b $29 ; )
                          dc.b $20 ; <space>
                          dc.b $4c ; l
                          dc.b $4f ; o
                          dc.b $41 ; a
                          dc.b $44 ; d
                          dc.b $53 ; s
                          dc.b $22 ; "
                          dc.b $00 ; ........
                          dc.b $b8 ; #.###...
                          dc.b $0a ; ....#.#.
                          dc.b $b4 ; #.##.#..
                          dc.b $00 ; ........
                          dc.b $99 ; <LIGHT GREEN>
                          dc.b $20 ; <space>
A_0a90                    dc.b $22 ; "
                          dc.b $41 ; a
                          dc.b $53 ; s
                          dc.b $53 ; s
                          dc.b $4f ; o
                          dc.b $43 ; c
                          dc.b $49 ; i
                          dc.b $41 ; a
                          dc.b $54 ; t
                          dc.b $45 ; e
                          dc.b $44 ; d
; -------------------------------------------------------------------------------------------------------------- ;
