; -------------------------------------------------------------------------------------------------------------- ;
; Snokie - Protected - In game variables
; -------------------------------------------------------------------------------------------------------------- ;
; Memory Layout
; -------------------------------------------------------------------------------------------------------------- ;
; Screens
; -------------------------------------------------------------------------------------------------------------- ;
SN_MemGameBase            = CI2_VIC_MemBase_0           ; $0000-$3fff
SN_MemScreenGame          = [SN_MemGameBase + $400]     ; $0400-$07ff
SN_MemScreenHiScore       = [SN_MemGameBase + $800]     ; $0c00-$0fff
; -------------------------------------------------------------------------------------------------------------- ;
; Charsets
; -------------------------------------------------------------------------------------------------------------- ;
; Menu      screen: VIC_Video_0400 / CharSet VIC_CharS_2800
; HighScore screen: VIC_Video_0800 / CharSet VIC_CharS_2800
; Game      screen: VIC_Video_0400 / CharSet VIC_CharS_2000
; -------------------------------------------------------------------------------------------------------------- ;
SN_MemCharSet_Game        = $2000                       ; $2000-$27ff
SN_MemCharSet_Info        = $2800                       ; $2800-$2bff

SN_MemCharSet_GfxInfo     = $1800                       ; $1800-$1fff
SN_MemCharSet_GfxGame     = $2000                       ; $2000-$27ff

SN_MemCharSet_TxtNormal   = $2800                       ; $2800-$2bff
SN_MemCharSet_TxtReverse  = $2c00                       ; $2c00-$2fff

SN_MemDataSprite          = $3000                       ; $3000-$3fff
SN_MemDataLevel           = $4000                       ; $4000-$6edf
SN_MemDataLevelCheck      = $6ee0                       ; $6ee0-$713d
SN_MemDataDemoMoves       = $914b                       ; $914b-$9290
; -------------------------------------------------------------------------------------------------------------- ;
; Screen Row Addresses
; -------------------------------------------------------------------------------------------------------------- ;
SN_Scrn_Rows              = VICSCN_ROW_NUM              ; 
SN_Scrn_RowLen            = VICSCN_ROW_LEN              ; 
; -------------------------------------------------------------------------------------------------------------- ;
SN_Scrn_Game              = SN_MemScreenGame            ; 
SN_Scrn_Game_Row_01         = [SN_Scrn_Game + [SN_Scrn_RowLen * $00]]    ; 
SN_Scrn_Game_Row_02         = [SN_Scrn_Game + [SN_Scrn_RowLen * $01]]    ; 
SN_Scrn_Game_Row_03         = [SN_Scrn_Game + [SN_Scrn_RowLen * $02]]    ; 
SN_Scrn_Game_Row_04         = [SN_Scrn_Game + [SN_Scrn_RowLen * $03]]    ; 
SN_Scrn_Game_Row_05         = [SN_Scrn_Game + [SN_Scrn_RowLen * $04]]    ; 
SN_Scrn_Game_Row_06         = [SN_Scrn_Game + [SN_Scrn_RowLen * $05]]    ; 
SN_Scrn_Game_Row_07         = [SN_Scrn_Game + [SN_Scrn_RowLen * $06]]    ; 
SN_Scrn_Game_Row_08         = [SN_Scrn_Game + [SN_Scrn_RowLen * $07]]    ; 
SN_Scrn_Game_Row_09         = [SN_Scrn_Game + [SN_Scrn_RowLen * $08]]    ; 
SN_Scrn_Game_Row_0a         = [SN_Scrn_Game + [SN_Scrn_RowLen * $09]]    ; 
SN_Scrn_Game_Row_0b         = [SN_Scrn_Game + [SN_Scrn_RowLen * $0a]]    ; 
SN_Scrn_Game_Row_0c         = [SN_Scrn_Game + [SN_Scrn_RowLen * $0b]]    ; 
SN_Scrn_Game_Row_0d         = [SN_Scrn_Game + [SN_Scrn_RowLen * $0c]]    ; 
SN_Scrn_Game_Row_0e         = [SN_Scrn_Game + [SN_Scrn_RowLen * $0d]]    ; 
SN_Scrn_Game_Row_0f         = [SN_Scrn_Game + [SN_Scrn_RowLen * $0e]]    ; 
SN_Scrn_Game_Row_10         = [SN_Scrn_Game + [SN_Scrn_RowLen * $0f]]    ; 
SN_Scrn_Game_Row_11         = [SN_Scrn_Game + [SN_Scrn_RowLen * $10]]    ; 
SN_Scrn_Game_Row_12         = [SN_Scrn_Game + [SN_Scrn_RowLen * $11]]    ; 
SN_Scrn_Game_Row_13         = [SN_Scrn_Game + [SN_Scrn_RowLen * $12]]    ; 
SN_Scrn_Game_Row_14         = [SN_Scrn_Game + [SN_Scrn_RowLen * $13]]    ; 
SN_Scrn_Game_Row_15         = [SN_Scrn_Game + [SN_Scrn_RowLen * $14]]    ; 
SN_Scrn_Game_Row_16         = [SN_Scrn_Game + [SN_Scrn_RowLen * $15]]    ; 
SN_Scrn_Game_Row_17         = [SN_Scrn_Game + [SN_Scrn_RowLen * $16]]    ; 
SN_Scrn_Game_Row_18         = [SN_Scrn_Game + [SN_Scrn_RowLen * $17]]    ; 
SN_Scrn_Game_Row_19         = [SN_Scrn_Game + [SN_Scrn_RowLen * $18]]    ; 
; -------------------------------------------------------------------------------------------------------------- ;
SN_Scrn_HiScore           = SN_MemScreenHiScore         ; 
SN_Scrn_HiScore_Row_01      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $00]] ; 
SN_Scrn_HiScore_Row_02      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $01]] ; 
SN_Scrn_HiScore_Row_03      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $02]] ; 
SN_Scrn_HiScore_Row_04      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $03]] ; 
SN_Scrn_HiScore_Row_05      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $04]] ; 
SN_Scrn_HiScore_Row_06      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $05]] ; 
SN_Scrn_HiScore_Row_07      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $06]] ; 
SN_Scrn_HiScore_Row_08      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $07]] ; 
SN_Scrn_HiScore_Row_09      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $08]] ; 
SN_Scrn_HiScore_Row_0a      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $09]] ; 
SN_Scrn_HiScore_Row_0b      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $0a]] ; 
SN_Scrn_HiScore_Row_0c      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $0b]] ; 
SN_Scrn_HiScore_Row_0d      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $0c]] ; 
SN_Scrn_HiScore_Row_0e      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $0d]] ; 
SN_Scrn_HiScore_Row_0f      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $0e]] ; 
SN_Scrn_HiScore_Row_10      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $0f]] ; 
SN_Scrn_HiScore_Row_11      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $10]] ; 
SN_Scrn_HiScore_Row_12      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $11]] ; 
SN_Scrn_HiScore_Row_13      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $12]] ; 
SN_Scrn_HiScore_Row_14      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $13]] ; 
SN_Scrn_HiScore_Row_15      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $14]] ; 
SN_Scrn_HiScore_Row_16      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $15]] ; 
SN_Scrn_HiScore_Row_17      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $16]] ; 
SN_Scrn_HiScore_Row_18      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $17]] ; 
SN_Scrn_HiScore_Row_19      = [SN_Scrn_HiScore + [SN_Scrn_RowLen * $18]] ; 
; -------------------------------------------------------------------------------------------------------------- ;
; Sprite Pointers and Storage
; -------------------------------------------------------------------------------------------------------------- ;
SN_GameSpritePtrs         = [SN_Scrn_Game + SPNTRS_OFF]    ; 
SN_GameSpritePtr_00       = [SN_GameSpritePtrs + $00]      ; 
SN_GameSpritePtr_01       = [SN_GameSpritePtrs + $01]      ; 
SN_GameSpritePtr_02       = [SN_GameSpritePtrs + $02]      ; 
SN_GameSpritePtr_03       = [SN_GameSpritePtrs + $03]      ; 
SN_GameSpritePtr_04       = [SN_GameSpritePtrs + $04]      ; 
SN_GameSpritePtr_05       = [SN_GameSpritePtrs + $05]      ; 
SN_GameSpritePtr_06       = [SN_GameSpritePtrs + $06]      ; 
SN_GameSpritePtr_07       = [SN_GameSpritePtrs + $07]      ; 
; -------------------------------------------------------------------------------------------------------------- ;
SN_HiScoreSpritePtrs      = [SN_Scrn_HiScore + SPNTRS_OFF] ; 
SN_HiScoreSpritePtr_00    = [SN_HiScoreSpritePtrs + $00]   ; 
SN_HiScoreSpritePtr_01    = [SN_HiScoreSpritePtrs + $01]   ; 
SN_HiScoreSpritePtr_02    = [SN_HiScoreSpritePtrs + $02]   ; 
SN_HiScoreSpritePtr_03    = [SN_HiScoreSpritePtrs + $03]   ; 
SN_HiScoreSpritePtr_04    = [SN_HiScoreSpritePtrs + $04]   ; 
SN_HiScoreSpritePtr_05    = [SN_HiScoreSpritePtrs + $05]   ; 
SN_HiScoreSpritePtr_06    = [SN_HiScoreSpritePtrs + $06]   ; 
SN_HiScoreSpritePtr_07    = [SN_HiScoreSpritePtrs + $07]   ; 
; -------------------------------------------------------------------------------------------------------------- ;
; Char Set Addresses
; -------------------------------------------------------------------------------------------------------------- ;
SN_CharSet_Game           = SN_MemCharSet_Game      ; $2000-$27ff
SN_CharSet_Info           = SN_MemCharSet_Info      ; $2800-$2bff

SN_CharSet_Gfx            = SN_MemCharSet_GfxInfo   ; $1800-$27ff
SN_CharSet_Txt            = SN_MemCharSet_TxtNormal ; $2800-$2fff
; -------------------------------------------------------------------------------------------------------------- ;
; Misc
; -------------------------------------------------------------------------------------------------------------- ;
SN_SnokieNumLivesGame     = $03 ; 
SN_SnokieNumLivesCheat    = $01 ; 

SN_HiScoreEntry_Max       = $0a ; 
; -------------------------------------------------------------------------------------------------------------- ;
SN_SnokieRockDist_Min     = $04 ; a rock falls if snokie distance value is lower
SN_SnokieOrbBigGap_Ri_Max = $08 ; big orb starts rolling right
SN_SnokieOrbBigGap_Le_Max = $17 ; big orb starts rolling left

SN_BeamDistTileChkData    = [TabTileChkData_L7_Beam_2 - TabTileChkData_L7_Beam_1] ; distance between 2 beams
SN_RayDistTileChkData     = [TabTileChkData_L5_Ray_2  - TabTileChkData_L5_Ray_1]  ; distance between 2 rays
; -------------------------------------------------------------------------------------------------------------- ;
SN_TileChkDataSlope_Le    = %10000000 ; slope left
SN_TileChkDataSlope_Ri    = %01000000 ; slope right
SN_TileChkDataDeath       = %11000000 ; death
SN_TileChkDataHeight      = %00111111 ; height
; -------------------------------------------------------------------------------------------------------------- ;
SN_LevelStartScrollPosX   = $50 ; 
; -------------------------------------------------------------------------------------------------------------- ;
SN_GetDataDummy           = $ffff ; 
; -------------------------------------------------------------------------------------------------------------- ;
