TXTTAB          = $2b   ; - $2c    Pointer: Start of BASIC Text Area ($0801)
VARTAB          = $2d   ; - $2e    Pointer: Start of BASIC Variables
ARYTAB          = $2f   ; - $30    Pointer: Start of BASIC Arrays
STREND          = $31   ; - $32    Pointer: End of BASIC Arrays + 1
FRETOP          = $33   ; - $34    Pointer: Bottom of String space
MEMSIZ          = $37   ; - $38    Pointer: Highest Address available to BASIC ($A000)

BASIC Program Text
Non-Array Variables and String Descriptors
Array Variables
Free Area (Reported by FRE(0))
String Text Area (Strings build from top of memory down into free area)
    
; -------------------------------------------------------------------------------------------------------------- ;
; BASIC program structure - default start at $0801
; -------------------------------------------------------------------------------------------------------------- ;
BAS_START                   = $0800                 ; unused - must be $00 to be able to run a BASIC pgm
BAS_STARTOK                   = $00                 ; 
BAS_PRGTEXT                 = [BAS_Start + $01]     ; 
BAS_PRGNEXTLINEPTR            = [BAS_Start + $01]   ; $0000 - End of BASIC Program
BAS_PRGNEXTLINEPTRLO            = [BAS_Start + $01] ; 
BAS_PRGNEXTLINEPTRHI            = [BAS_Start + $02] ; 
BAS_PRGLINENUMBER             = [BAS_Start + $03]   ; 
BAS_PRGLINENUMBERLO             = [BAS_Start + $03] ; 
BAS_PRGLINENUMBERHI             = [BAS_Start + $04] ; 
BAS_TOKEN                     = [BAS_Start + $05]   ; 
BAS_LINETEXT                  = [BAS_Start + $05]   ; 
BAS_LINETEXTMAX                 = $50               ; 80 chars in two lines of 40 chars each 
BAS_LINETEXTEND                 = $00               ; 
; -------------------------------------------------------------------------------------------------------------- ;
; BASIC command primary tokens
; -------------------------------------------------------------------------------------------------------------- ;
BAS_TK_END           = $80 ; 
BAS_TK_FOR           = $81 ; 
BAS_TK_NEXT          = $82 ; 
BAS_TK_DATA          = $83 ; 
BAS_TK_INPUT#        = $84 ; 
BAS_TK_INPUT         = $85 ; 
BAS_TK_DIM           = $86 ; 
BAS_TK_READ          = $87 ; 
BAS_TK_LET           = $88 ; 
BAS_TK_GOTO          = $89 ; 
BAS_TK_RUN           = $8a ; 
BAS_TK_IF            = $8b ; 
BAS_TK_RESTORE       = $8c ; 
BAS_TK_GOSUB         = $8d ; 
BAS_TK_RETURN        = $8e ; 
BAS_TK_REM           = $8f ; 
BAS_TK_STOP          = $90 ; 
BAS_TK_ON            = $91 ; 
BAS_TK_WAIT          = $92 ; 
BAS_TK_LOAD          = $93 ; 
BAS_TK_SAVE          = $94 ; 
BAS_TK_VERIFY        = $95 ; 
BAS_TK_DEF           = $96 ; 
BAS_TK_POKE          = $97 ; 
BAS_TK_PRINT#        = $98 ; 
BAS_TK_PRINT         = $99 ; 
BAS_TK_CONT          = $9a ; 
BAS_TK_LIST          = $9b ; 
BAS_TK_CLR           = $9c ; 
BAS_TK_CMD           = $9d ; 
BAS_TK_SYS           = $9e ; 
BAS_TK_OPEN          = $9f ; 
BAS_TK_CLOSE         = $a0 ; 
BAS_TK_GET           = $a1 ; 
BAS_TK_NEW           = $a2 ; 
; -------------------------------------------------------------------------------------------------------------- ;
; BASIC command secondary tokens
; -------------------------------------------------------------------------------------------------------------- ;
BAS_TK_TAB           = $a3 ; 
BAS_TK_TO            = $a4 ; 
BAS_TK_FN            = $a5 ; 
BAS_TK_SPC           = $a6 ; 
BAS_TK_THEN          = $a7 ; 
BAS_TK_NOT           = $a8 ; 
BAS_TK_STEP          = $a9 ; 
; -------------------------------------------------------------------------------------------------------------- ;
; BASIC arithmetic/logic operator tokens
; -------------------------------------------------------------------------------------------------------------- ;
BAS_TK_PLUS          = $aa ;       + (Addition)
BAS_TK_MINUS         = $ab ;       − (Subtraction)
BAS_TK_MULT          = $ac ;       * (Multiplication)
BAS_TK_DIV           = $ad ;       / (Division)
BAS_TK_POWER         = $ae ;       ^ (Power)
BAS_TK_AND           = $af ; 
BAS_TK_OR            = $b0 ; 
BAS_TK_GT            = $b1 ;     > (greater-than operator)
BAS_TK_EQ            = $b2 ;     = (equals operator)
BAS_TK_LT            = $b3 ;     < (less-than operator)
BAS_TK_SGN           = $b4 ; 
BAS_TK_INT           = $b5 ; 
BAS_TK_ABS           = $b6 ; 
BAS_TK_USR           = $b7 ; 
BAS_TK_FRE           = $b8 ; 
; -------------------------------------------------------------------------------------------------------------- ;
; BASIC function tokens
; -------------------------------------------------------------------------------------------------------------- ;
BAS_TK_POS           = $b9 ; 
BAS_TK_SQR           = $ba ; 
BAS_TK_RND           = $bb ; 
BAS_TK_LOG           = $bc ; 
BAS_TK_EXP           = $bd ; 
BAS_TK_COS           = $be ; 
BAS_TK_SIN           = $bf ; 
BAS_TK_TAN           = $c0 ; 
BAS_TK_ATN           = $c1 ; 
BAS_TK_PEEK          = $c2 ; 
BAS_TK_LEN           = $c3 ; 
BAS_TK_STRS          = $c4 ; 
BAS_TK_VAL           = $c5 ; 
BAS_TK_ASC           = $c6 ; 
BAS_TK_CHRS          = $c7 ; 
BAS_TK_LEFTS         = $c8 ; 
BAS_TK_RIGHTS        = $c9 ; 
BAS_TK_MIDS          = $ca ; 
; -------------------------------------------------------------------------------------------------------------- ;
; BASIC command token
; -------------------------------------------------------------------------------------------------------------- ;
BAS_TK_GO            = $CB ; 
BAS_TK_PI            = $FF ; 
; -------------------------------------------------------------------------------------------------------------- ;
