; -------------------------------------------------------------------------------------------------------------- ;
; 1541 - BAM Block - 18,00
; -------------------------------------------------------------------------------------------------------------- ;
BAMLINK           = $00         ; link to the next DIR block
BAMLINKTRK          = $00       ; track location of the first DIR entry block
BAMLINKTRK_1541       = $12     ; 
BAMLINKSEC          = $01       ; sector location of the first DIR entry block
BAMLINKSEC_1541       = $01     ; 
BAMDOSVRS         = $02         ; disk DOS version type
BAMDOSVRS_1541      = $41       ; "A"
BAMNOUSE          = $03         ; unsused
; -------------------------------------------------------------------------------------------------------------- ;
; BAM bit patterns - entries for each track in groups of four bytes per track
; -------------------------------------------------------------------------------------------------------------- ;
BAMIMG            = $04         ; start BAM
BAMIMG_Z01         = $04        ; zone 1 - tracks 00-17 - outer tracks
BAMIMG_Z01_MIN       = $01      ;        - start track numer
BAMIMG_Z01_MAX       = $11      ;        - final track number
BAMIMG_Z01_NUM       = $15      ;        - 21 sectors per track (00-20)
                                ; 
BAMIMG_T01        = BAMIMG             ; $04
BAMIMG_FREE         = [BAMIMG_T01 + $00] ; number of free sectors on that track
BAMIMG_PAT01        = [BAMIMG_T01 + $01] ; bit pattern sector 00-07
BAMIMG_PAT02        = [BAMIMG_T01 + $02] ; bit pattern sector 08-15
BAMIMG_PAT03        = [BAMIMG_T01 + $03] ; bit pattern sector 16-24
BAMIMG_LEN          = [BAMIMG_PAT03 - BAMIMG_FREE + $01] ; BAM entry length
                                ; 
BAMIMG_T02        = [BAMIMG_LEN * $02] ; $08
BAMIMG_T03        = [BAMIMG_LEN * $03] ; $0c
BAMIMG_T04        = [BAMIMG_LEN * $04] ; $10
BAMIMG_T05        = [BAMIMG_LEN * $05] ; $14
BAMIMG_T06        = [BAMIMG_LEN * $06] ; $18
BAMIMG_T07        = [BAMIMG_LEN * $07] ; $1c
BAMIMG_T08        = [BAMIMG_LEN * $08] ; $20
BAMIMG_T09        = [BAMIMG_LEN * $09] ; $24
BAMIMG_T00        = [BAMIMG_LEN * $0a] ; $28
BAMIMG_T11        = [BAMIMG_LEN * $0b] ; $2c
BAMIMG_T12        = [BAMIMG_LEN * $0c] ; $30
BAMIMG_T13        = [BAMIMG_LEN * $0d] ; $34
BAMIMG_T14        = [BAMIMG_LEN * $0e] ; $38
BAMIMG_T15        = [BAMIMG_LEN * $0f] ; $3c
BAMIMG_T16        = [BAMIMG_LEN * $10] ; $40
BAMIMG_T17        = [BAMIMG_LEN * $11] ; $44
; -------------------------------------------------------------------------------------------------------------- ;
BAMIMG_Z02        = $48         ; zone 2 - tracks 18-24 
BAMIMG_Z02_MIN      = $12       ;        - 18 = start track numer
BAMIMG_Z02_MAX      = $18       ;        - 24 = final track number
BAMIMG_Z02_NUM      = $13       ;        - 19 = sectors per track (00-18)
                                ; 
BAMIMG_T18        = [BAMIMG_LEN * $12] ; $48
BAMIMG_T19        = [BAMIMG_LEN * $13] ; $4c
BAMIMG_T20        = [BAMIMG_LEN * $14] ; $50
BAMIMG_T21        = [BAMIMG_LEN * $15] ; $54
BAMIMG_T22        = [BAMIMG_LEN * $16] ; $58
BAMIMG_T23        = [BAMIMG_LEN * $17] ; $5c
BAMIMG_T24        = [BAMIMG_LEN * $18] ; $60
; -------------------------------------------------------------------------------------------------------------- ;
BAMIMG_Z03        = $64         ; zone 3 - tracks 25-30
BAMIMG_Z03_MIN      = $19       ;        - 25 = start track numer
BAMIMG_Z03_MAX      = $1e       ;        - 30 = final track number
BAMIMG_Z03_NUM      = $12       ;        - 18 = sectors per track (00-17)
                                ; 
BAMIMG_T25        = [BAMIMG_LEN * $19] ; $64
BAMIMG_T26        = [BAMIMG_LEN * $1a] ; $68
BAMIMG_T27        = [BAMIMG_LEN * $1b] ; $6c
BAMIMG_T28        = [BAMIMG_LEN * $1c] ; $70
BAMIMG_T29        = [BAMIMG_LEN * $1d] ; $74
BAMIMG_T30        = [BAMIMG_LEN * $1e] ; $78
; -------------------------------------------------------------------------------------------------------------- ;
BAMIMG_Z04        = $7c         ; zone 4 - tracks 31-35 - inner tracks
BAMIMG_Z04_MIN      = $1f       ;        - 31 = start track numer
BAMIMG_Z04_MAX      = $23       ;        - 35 = final track number
BAMIMG_Z04_NUM      = $11       ;        - 17 = sectors per track (00-16)
                                ; 
BAMIMG_T31        = [BAMIMG_LEN * $1f] ; $7c
BAMIMG_T32        = [BAMIMG_LEN * $20] ; $80
BAMIMG_T33        = [BAMIMG_LEN * $21] ; $84
BAMIMG_T34        = [BAMIMG_LEN * $22] ; $88
BAMIMG_T35        = [BAMIMG_LEN * $23] ; $8c
; -------------------------------------------------------------------------------------------------------------- ;
BAMDISKHDR        = $90         ; disk header start
BAMDISKNAM          = $90       ; disk name (padded with $a0)
BAMDISKNAM_LEN      = [BAMFILLER - BAMDISKNAM - $01] ; 
BAMFILLER           = $a0       ; 
BAMFILLER1            = $a0     ; 
BAMFILLER1_1541       = BAMFILLCHAR ; 
BAMFILLER2            = $a1     ; 
BAMFILLER2_1541       = BAMFILLCHAR ; 
BAMFILLCHAR             = $a0   ; <shift space>
BAMDISKID           = $a2       ; 
BAMDISKID1            = $a2     ; 
BAMDISKID1_1541         = $30   ; default: '0'
BAMDISKID2            = $a3     ; 
BAMDISKID2_1541         = $30   ; default: '0'
BAMDOSTYP           = $a5       ; 
BAMDOSTYP1            = $a5     ; 
BAMDOSTYP1_1541         = $32   ; '2'
BAMDOSTYP2            = $a6     ; 
BAMDOSTYP2_1541         = $41   ; 'A'
BAMDISKHDR_LEN      = [BAMPAD - BAMDISKHDR - $01] ; 
; -------------------------------------------------------------------------------------------------------------- ;
BAMPAD            = $a7         ; filled with BAMFILLCHAR <shift space>
BAMPAD_LEN        = [BAMFREE - BAMPAD - $01] ; 
; -------------------------------------------------------------------------------------------------------------- ;
BAMFREE           = $ab         ; unsused - sometimes set to 'BLOCKS FREE'
BAMEND            = $ff         ; 
; -------------------------------------------------------------------------------------------------------------- ;
