; -------------------------------------------------------------------------------------------------------------- ;
; VC1541 - DOS System Constants
; -------------------------------------------------------------------------------------------------------------- ;
LED1              = $00         ; no led on
NOTRDY            = $00         ; i/o not ready
RDMODE            = $00         ; open read mode
VAL               = $00         ; job code for validate
DATIN             = $01         ; data in line
LISNER            = $01         ; serial listener flag
MASK4             = $01         ; bit mask for gcr conversion
RDYLST            = $01         ; ready to listen
SEQTYP            = $01         ; open sequential type
WTMODE            = $01         ; open write mode
APMODE            = $02         ; open append mode
DATOUT            = $02         ; data out
DOSVER            = $02         ; dos version
PRGTYP            = $02         ; open program type
TOLONG            = $02         ; format error: can't find sync mark
MASK7             = $03         ; bit mask for gcr conversion
MDMODE            = $03         ; open modify mode
TOMANY            = $03         ; format error: too many counts
USRTYP            = $03         ; open user type
CLKIN             = $04         ; clock in
CMDCHN            = $04         ; command channel number
GAP2              = $04         ; minimum size of gap after data block
NMODES            = $04         ; number of mudes in tables modlst (SFEB6 : 'rwam')
RELTYP            = $04         ; open relative type
TOBIG             = $04         ; format error: not enough space
BFCNT             = $05         ; available buffer count
ERRCHN            = $05         ; error channel number
MXFILS            = $05         ; maximum number of filenames in string
NTYPES            = $05         ; number of different file types ($FEB8 : 'dspur')
NUMSYN            = $05         ; gcr byte count for size of sync area
TOSMAL            = $05         ; format error: gap2 too small
BLINDX            = $05         ; bam lindx for floating bams
MXCHNS            = $06         ; maximum number of channels in svstem
NBCMDS            = $06         ; number of block commands ($CC5D : 'afrwep')
NOTFND            = $06         ; format error: file not found
NSSL              = $06         ; number of side-sector links
NUMJOB            = $06         ; number of jobs
RDMAX             = $06         ; sector distance wait
DIRTYP            = $07         ; open direct file type
MASK2             = $07         ; bit mask for gcr conversion
TYPMSK            = $07         ; mask for type bits
VERERR            = $07         ; controller verify error
CLKOUT            = $08         ; clock out
EOISND            = $08         ; not(eoi) to send
EOI               = $08         ; not(eoi) to send
LED0              = $08         ; active led
GAP1              = $09         ; gap after header to dear erase in gcr
WRTMIN            = $09         ; write minimum
CBPTR             = $0a         ; command buffer pointer
LDCMD             = $0c         ; load command image
MSGLEN            = $0c         ; length of 'blocks free' message at JC817
NCMDS             = $0c         ; number of commands ('vidmbup&crsn')
WRTMAX            = $0c         ; write maximum
CR                = $0d         ; carriage return
CMDSA             = $0f         ; command channel secondary address number
LXINT             = $0f         ; power up logical index usage (linuse)
MASK5             = $0f         ; bit mask for gcr conversion
ATNA              = $10         ; atn active
ERRSA             = $10         ; error channel secondary address number
SSIOFF            = $10         ; offset into ss for data block pointers
IRSA              = $11         ; internal read secondary address number
IWSA              = $12         ; internal write secondary address number
MAXSA             = $12         ; maximum secondary address number plus one
DIRLEN            = $18         ; directory length used
NBSIZ             = $1b         ; nambuf text size
MASK8             = $1f         ; bit mask for gcr conversion
OVRFLO            = $20         ; rr print overflow
CMDLEN            = $29         ; length of command buffer
SKIP2             = $2c         ; bit abs
BADSYN            = $30         ; error: general syntax
BADCMD            = $31         ; error: invalid command
LONGLN            = $32         ; error: long line
BADFN             = $33         ; error: invalid filename
NOFILE            = $34         ; error: no file given
NOCFIL            = $39         ; error: command file not found
TIM               = $3a         ; irq rate for 15 ms
MASK3             = $3e         ; bit mask for gcr conversion
UNLSN             = $3f         ; unlisten command
BUMPC             = $40         ; bump command
DYF1LE            = $40         ; dirty flag for rr file
FM4040            = $41         ; 4040 format version
FM2030            = $42         ; 2030 format version
TOPRD             = $45         ; top of read overflow buffer on a read
TOPWRT            = $45         ; top of write overflow buffer in a write
JMPC              = $50         ; jump command
NOREC             = $50         ; error: record not present
RECOVF            = $51         ; error: overflow in record
BIGFIL            = $52         ; error: file too large
UNTLK             = $5f         ; untalk command
EXECD             = $60         ; execute command
FILOPN            = $60         ; error: file open
FILNOP            = $61         ; error: file not open
FLNTFD            = $62         ; error: file not found
FLEXST            = $63         ; error: file exists error
MISTYP            = $64         ; error: file type mismatch
NOBLK             = $65         ; error: no block
BADTS             = $66         ; error: illegal track or sector
SYSTS             = $67         ; error: illegal system track or sector
NOCHNL            = $70         ; error: no channels available
DIRERR            = $71         ; error: directory error
DSKFUL            = $72         ; error: diskette full
CBMV2             = $73         ; 'cbm dos v2.6 vl70' message number
NODRIV            = $74         ; error: drive not ready
NSSP              = $78         ; number of pointers in side sector
MASK6             = $7d         ; bit mask for gcr conversion
ATN               = $80         ; atn in
EOIOUT            = $80         ; talk with eoi
LRF               = $80         ; last record flag
MASK5X            = $80         ; bit mask for gcr conversion
READ              = $80         ; controller job type: read
TALKER            = $80         ; talker flag
RNDEOI            = $81         ; random with eoi
RDYTLK            = $88         ; talk no eoi
RNDRDY            = $89         ; random chnrdy
WRITE             = $90         ; controller job type: write
WVERFY            = $a0         ; controller job type: verify
SEEK              = $b0         ; controller job type: seek
BUMP              = $c0         ; controller job type: bump
MASK2X            = $c0         ; bit mask for gcr conversion
JUMPC             = $d0         ; controller job type: jump
EXEC              = $e0         ; controller job type: execute
MASK7X            = $e0         ; bit mask for gcr conversion
MASK4X            = $f0         ; bit mask for gcr conversion
MASK1             = $f8         ; bit mask for gcr conversion
; -------------------------------------------------------------------------------------------------------------- ;
